from ExtensionClass import Base
from ComputedAttribute import ComputedAttribute
from DocumentTemplate.DT_Util import Eval, expr_globals, TemplateDict, \
    InstanceDict, cDocument


class Expression(Base):  # Expression object that can be pickled

    def __init__(self, expr):
        self.expr = expr
        
    def _v_expr(self, expr_globals=expr_globals, Eval=Eval):
        self._v_expr = Eval(self.expr, expr_globals)
        return self._v_expr

    _v_expr = ComputedAttribute(_v_expr)

    def __getstate__(self):
        d = self.__dict__.copy()
        if d.has_key('_v_expr'):
            del d['_v_expr']
        return d

    def __setstate__(self, state):
        d = self.__dict__
        d.clear(); d.update(state)
        
    def eval(self,mapping):
        return self._v_expr.eval(mapping)

    def __call__(self,**kw):
        return apply(self._v_expr,(),kw)









class _td(TemplateDict, cDocument):
    pass

def NamespaceStack(REQUEST):
    t = _td()
    if hasattr(REQUEST, 'AUTHENTICATED_USER'):
        t.AUTHENTICATED_USER = REQUEST.AUTHENTICATED_USER
    return t

    
class Name:
    def __init__(self,name,call=1):
        self.name, self.call = name, call

    def eval(self,md):
        return md.getitem(self.name,self.call)


del Eval, expr_globals, TemplateDict, cDocument, Base, ComputedAttribute

