import Rack, Specialists, Customizers, AttributeProviders, SheetProviders
import DataSkins, Agents, Providers

from zLOG import register_subsystem
register_subsystem('ZPatterns')

def initialize(context):

    Rack.initialize(context)
    Specialists.initialize(context)
    Customizers.initialize(context)
    AttributeProviders.initialize(context)
    SheetProviders.initialize(context)
    DataSkins.initialize(context)
    Providers.initialize(context)
    Agents.initialize(context)

    if hasattr(context,'registerHelp'):
        context.registerHelp()

# The only way to register extra permissions for a ZClass base at present
# Waaaa
__ac_permissions__ = (
    ('Delete rack-mounted objects', ()),
)
